"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
/**
 * AsyncView
 */
var AsyncComponent = /** @class */ (function (_super) {
    __extends(AsyncComponent, _super);
    function AsyncComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.unmount = false;
        _this.state = {
            component: null,
        };
        return _this;
    }
    AsyncComponent.prototype.componentWillUnmount = function () {
        this.unmount = true;
    };
    AsyncComponent.prototype.componentDidMount = function () {
        return __awaiter(this, void 0, void 0, function () {
            var render, component, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        render = this.props.render;
                        if (this.unmount)
                            return [2 /*return*/];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, render()];
                    case 2:
                        component = (_a.sent()).default;
                        this.setState({ component: component });
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        console.error(e_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    AsyncComponent.prototype.render = function () {
        var _a = this.props, placeholder = _a.placeholder, children = _a.children;
        var C = this.state.component;
        React.createElement(C, this.props, children);
        return C ? React.createElement(C, __assign({}, this.props)) : placeholder;
    };
    AsyncComponent.defaultProps = {
        render: function () { return null; },
        placeholder: null,
    };
    return AsyncComponent;
}(React.Component));
exports.default = AsyncComponent;
/**
 * asyncView container
 *
 * @author gcy[fo1518]
 * code split and lazy load
 * func retrun react container component
 */
exports.asyncViewFactory = function (render, opt, placeholder) {
    if (placeholder === void 0) { placeholder = null; }
    return _a = /** @class */ (function (_super) {
            __extends(class_1, _super);
            function class_1(props) {
                var _this = _super.call(this, props) || this;
                _this.unmount = false;
                _this.state = {
                    component: null,
                };
                return _this;
            }
            class_1.prototype.componentWillUnmount = function () {
                this.unmount = true;
            };
            class_1.prototype.componentDidMount = function () {
                return __awaiter(this, void 0, void 0, function () {
                    var render, component, e_2;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                render = this.props.render;
                                if (this.unmount)
                                    return [2 /*return*/];
                                _a.label = 1;
                            case 1:
                                _a.trys.push([1, 3, , 4]);
                                return [4 /*yield*/, render()];
                            case 2:
                                component = (_a.sent()).default;
                                this.setState({ component: component });
                                return [3 /*break*/, 4];
                            case 3:
                                e_2 = _a.sent();
                                console.error(e_2);
                                return [3 /*break*/, 4];
                            case 4: return [2 /*return*/];
                        }
                    });
                });
            };
            class_1.prototype.render = function () {
                var C = this.state.component;
                return C ? React.createElement(C, __assign({}, this.props)) : placeholder;
            };
            return class_1;
        }(React.Component)),
        _a.defaultProps = __assign({}, opt),
        _a;
    var _a;
};
