/// <reference types="react" />
import * as React from "react";
/**
 * chunk page container
 *
 * @author gcy[of1518]
 * @date 2017.06
 */
export default class ChunkView extends React.Component<any, any> {
    static defaultProps: {
        entries: any[];
    };
    constructor(props: any);
    componentDidMount(): void;
    render(): JSX.Element;
    /**
     * 递归遍历所有路由
     *
     * @param { Array } entries
     */
    routeContainer: (entries: any[]) => JSX.Element;
    /**
     * 加载Chunk（页面分片chunkFile.js入口）
     *
     * @param {any} param chunk name
     */
    loadChunk: (param: any) => Promise<{}>;
}
